
package de.ivu.elect.business.stimmzettel.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatum;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractStimmzettelKopfdatumEdit {

  @Inject
  protected StimmzettelKopfdatumDAO dao;

  @Inject
  protected StimmzettelKopfdatumExtendedDAO extendedDao;

  public void delete(StimmzettelKopfdatum entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(StimmzettelKopfdatum entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(StimmzettelKopfdatum entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected StimmzettelKopfdatum getAttachedEntity(StimmzettelKopfdatum entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected StimmzettelKopfdatum getAttachedAndRefreshedEntity(StimmzettelKopfdatum entity) {
    return dao.refresh(entity);
  }
}
